require "defines"

game.oninit(function()
  glob.itemcollectors = {}
  glob.debug = true -- change to disable debug printing
end)

game.onload(function()
  if not glob.itemcollectors then glob.itemcollectors = {} end
  if not glob.debug then glob.debug = false end 
end)

game.onevent(defines.events.onbuiltentity, function(event)
  if event.createdentity.name == "wooden-chest" then
    table.insert(glob.itemcollectors, event.createdentity) 
    debugPrint("inserted into table")
  end
end)

game.onevent(defines.events.ontick, function(event)
  if event.tick%60 == 0 and #glob.itemcollectors > 0 then
    local items = {}
    local itemstack = {}
    for index, collector in ipairs(glob.itemcollectors) do
      if collector.valid then
        items=game.findentitiesfiltered{type="item-entity", area=getBoundingBox(collector.position, 30)}
        for _, item in ipairs(items) do
          itemstack = {name=item.stack.name, count=item.stack.count}
          debugPrint(itemstack)
          if item.valid and (itemstack.name == "alien-artifact" or itemstack.name == "small-alien-artifact") then
            if collector.caninsert(itemstack) then
              debugPrint("inserting")
              collector.insert(itemstack)
              item.destroy()
            end
          end
        end
      else -- collector was not valid
        table.remove(glob.itemcollectors, index)
      end
    end
  end
end)

function getBoundingBox(position, radius)
  return {{position.x-radius,position.y-radius},{position.x+radius,position.y+radius}}
end

function debugPrint(string)
  if glob.debug then game.player.print(serpent.block(string)) end
end

