game.oninit(function() --create refineries table on new game
  if not glob.refineries then glob.refineries = {} end
end)

game.onload(function()
  --create refineries table on load (if it does not exist)
  if not glob.refineries then glob.refineries = {} end
end)

game.onevent(defines.events.onbuiltentity, function(event)
  if event.createdentity.name = "refinery" then
    table.insert(glob.refineries, event.createdentity) 
  end
end)

game.onevent(defines.events.ontick, function()
  if game.tick % 60 == 0 then
    for index, refinery in ipairs(glob.refineries) do
      if refinery.valid then
        if refinery.getitemcount() > 0 then -- the refinery has items
          -- the inventory number may be wrong... the [1] selects 
          -- the first item stack in the inventory
          local item = refinery.getinventory(1)[1] 
          local itemAmount = 7 -- stack size
          -- make sure we don't accidentally give free items...
          if item.count < itemAmount then itemAmount = item.count end 

          -- you'll probably need to play with these number to get it to
          -- place where you want it to...
          -- there is also refinery.direction which tells you whether
          -- the refinery is pointing north, south etc. so if you get
          -- ambitious you can try to make it place the output to the
          -- same relative side rather than always in one direction...
          local storagePos = {refinery.position.x + 5, refinery.position.y + 5}
          -- get any entities at that storagePosition
          local storageEntities = game.findentities(storagePos) 
          local storageEntity = false -- temp bool
          for _, entity in ipairs(storageEntities) do
            if entity.caninsert(item) then
              storageEntity = entity -- save a reference to this entity
              break -- and break out of the loop
            end
          end
          if storageEntity then
            storageEntity.insert(item)
            refinery.remove(item)
          elseif storageEntities == nil then -- no entities at all 
            -- just place the item on the ground
            game.createentity{name="item-on-ground", position=storagePos, stack=item}
          end
        end
      else -- not a valid refinery anymore
        table.remove(glob.refineries, index) -- remove from table
      end
    end
  end
end)

